%define rel 6
%define rhrel %([ -f /etc/redhat-release ] && rpm -q --qf %{VERSION} redhat-release)
%define rhtag %([ -n "%{rhrel}" ] && echo .%{rhrel})
BuildPreReq: gcc, grep
%define gccok "%(gcc -dumpversion | grep 2.96)"
%if %{gccok}
%define gccreq gcc = 2.96
%define gcc gcc
%else
%define gccreq compat-gcc = 7.3
%define gcc gcc296
%endif

Summary: Memtest-86
Name: memtest86
Version: 3.0
Release: %{rel}%{rhtag}
License: GPL
ExclusiveArch: i386
ExclusiveOS: Linux
Prereq: grep
Group: System Environment/Base
Source: http://www.memtest86.com/%{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPreReq: %{gccreq}

%changelog
* Tue May 20 2003 Peter Soos <sp@osb.hu>
- Fixed /boot problem in grub.conf
- Improved gcc workaround

* Mon Feb 03 2003 Peter Soos <sp@osb.hu>
- Fixed gcc3 compilation problem

* Fri Dec 13 2002 Peter Soos <sp@osb.hu>
- Fixed lilo problem

* Fri Aug 23 2002 Peter Soos <sp@osb.hu>
- Removed bootloader dependencies
- Moved to version 3.0

* Sun Jun 02 2002 Peter Soos <sp@osb.hu>
- Moved to RedHat Linux 7.3

* Sat Oct 06 2001 Peter Soos  <sp@osb.hu>
- Moved to RedHat Linux 7.2 beta
- Removed the automatic LILO configuration to support GRUB too
- Added GRUB support

* Fri Sep 06 2001 Peter Soos  <sp@osb.hu>
- Moved to version 2.7

* Fri May 04 2001 Peter Soos  <sp@osb.hu>
- Rebuilt under RedHat Linux 7.1
- Added versioning

* Wed Apr 18 2001 Peter Soos <sp@osb.hu>
- Moved to RedHat Linux 7.0

* Sun Feb 11 2001 Peter Soos <sp@osb.hu>
- Moved to version 2.5

* Mon Jul 31 2000 Peter Soos <sp@osb.hu>
- Moved to version 2.4

* Mon Feb 28 2000 Peter Soos <sp@osb.hu>
- Moved to version 2.2

* Fri Dec 25 1998 Peter Soos <sp@osb.hu>
- Corrected the file attributes

* Mon Aug 17 1998 Peter Soos <sp@osb.hu>
- Moved to 1.4a

* Mon Jun 22 1998 Peter Soos <sp@osb.hu>
- Moved to 1.4

* Wed Dec 31 1997 Peter Soos <sp@osb.hu>
- Initial version

%description
Memtest86 is thorough, stand alone memory test for 386, 486 and Pentium systems. Memtest86 is a stand alone program and can be loaded from either a disk partition via lilo or a floppy disk. Memtest86 uses a "moving inversions" algorithm that is proven to be effective in finding memory errors.  The BIOS based memory test is just a quick check that will often miss many of the failures that are detected by Memtest86.

%prep
%setup

%build
make "CC=/usr/bin/%{gcc}"

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/boot
install -m644 memtest.bin %{buildroot}/boot/memtest86-%{version}-%{release}

%clean
rm -rf %{buildroot}

%post
ln -sf memtest86-%{version}-%{release} /boot/memtest86
if [ -f /etc/lilo.conf ] ; then
	cp -f /etc/lilo.conf /etc/lilo.conf.orig
	grep -v memtest /etc/lilo.conf.orig > /etc/lilo.conf
	echo "image=/boot/memtest86-%{version}-%{release}" >> /etc/lilo.conf
	echo "	label=memtest" >> /etc/lilo.conf
fi
if [ -f /boot/grub/grub.conf ] ; then
	cp -f /boot/grub/grub.conf /boot/grub/grub.conf.orig
	grep -E -v "[mM]emtest.*%{version}-%{release}" /boot/grub/grub.conf.orig > /boot/grub/grub.conf
	if mount |grep "on */boot" > /dev/null; then
		BOOT=""
	else
		BOOT="/boot"
	fi
	echo "title Memtest86 (%{version}-%{release})" >> /boot/grub/grub.conf
	echo "	kernel ${BOOT}/memtest86-%{version}-%{release}" >> /boot/grub/grub.conf
fi


%preun
rm /boot/memtest86
if [ -f /etc/lilo.conf ] ; then
	cp -f /etc/lilo.conf /etc/lilo.conf.orig
	grep -v "memtest" /etc/lilo.conf.orig > /etc/lilo.conf
fi
if [ -f /boot/grub/grub.conf ] ; then
	cp -f /boot/grub/grub.conf /boot/grub/grub.conf.orig
	grep -E -v "[mM]emtest.*%{version}-%{release}" /boot/grub/grub.conf.orig > /boot/grub/grub.conf
fi

%files
%defattr(0644, root, root, 0755)
%doc README
/boot/memtest86-%{version}-%{release}
